<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;humantime-2.1.0&#x2F;src&#x2F;lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../humantime/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
</pre><pre class="rust"><code><span class="doccomment">//! Human-friendly time parser and formatter</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Features:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * Parses durations in free form like `15days 2min 2s`</span>
<span class="doccomment">//! * Formats durations in similar form `2years 2min 12us`</span>
<span class="doccomment">//! * Parses and formats timestamp in `rfc3339` format: `2018-01-01T12:53:00Z`</span>
<span class="doccomment">//! * Parses timestamps in a weaker format: `2018-01-01 12:53:00`</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Timestamp parsing/formatting is super-fast because format is basically</span>
<span class="doccomment">//! fixed.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! See [humantime-serde] for serde integration (previous crate [serde-humantime] looks unmaintained).</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [serde-humantime]: https://docs.rs/serde-humantime/0.1.1/serde_humantime/</span>
<span class="doccomment">//! [humantime-serde]: https://docs.rs/humantime-serde</span>

<span class="attribute">#![<span class="ident">forbid</span>(<span class="ident">unsafe_code</span>)]</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">missing_debug_implementations</span>)]</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">missing_docs</span>)]</span>

<span class="kw">mod</span> <span class="ident">duration</span>;
<span class="kw">mod</span> <span class="ident">wrapper</span>;
<span class="kw">mod</span> <span class="ident">date</span>;

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::duration</span>::{<span class="ident">parse_duration</span>, <span class="ident">Error</span> <span class="kw">as</span> <span class="ident">DurationError</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::duration</span>::{<span class="ident">format_duration</span>, <span class="ident">FormattedDuration</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::wrapper</span>::{<span class="ident">Duration</span>, <span class="ident">Timestamp</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::date</span>::{<span class="ident">parse_rfc3339</span>, <span class="ident">parse_rfc3339_weak</span>, <span class="ident">Error</span> <span class="kw">as</span> <span class="ident">TimestampError</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::date</span>::{
    <span class="ident">format_rfc3339</span>, <span class="ident">format_rfc3339_micros</span>, <span class="ident">format_rfc3339_millis</span>, <span class="ident">format_rfc3339_nanos</span>,
    <span class="ident">format_rfc3339_seconds</span>,
};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::date</span>::{<span class="ident">Rfc3339Timestamp</span>};
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="humantime" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>